<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/ref.outcontrol.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'zh',
  ),
  'this' => 
  array (
    0 => 'function.ob-list-handlers.php',
    1 => 'ob_list_handlers',
  ),
  'up' => 
  array (
    0 => 'ref.outcontrol.php',
    1 => '输出控制 函数',
  ),
  'prev' => 
  array (
    0 => 'function.ob-implicit-flush.php',
    1 => 'ob_implicit_flush',
  ),
  'next' => 
  array (
    0 => 'function.ob-start.php',
    1 => 'ob_start',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'zh',
    'path' => 'reference/outcontrol/functions/ob-list-handlers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="function.ob-list-handlers" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">ob_list_handlers</h1>
  <p class="verinfo">(PHP 4 &gt;= 4.3.0, PHP 5, PHP 7, PHP 8)</p><p class="refpurpose"><span class="refname">ob_list_handlers</span> &mdash; <span class="dc-title">列出所有使用的输出处理程序</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-function.ob-list-handlers-description">
  <h3 class="title">说明</h3>
  <div class="methodsynopsis dc-description">
   <span class="methodname"><strong>ob_list_handlers</strong></span>(): <span class="type"><a href="language.types.array.php" class="type array">array</a></span></div>

  <p class="para rdfs-comment">
   列出所有使用的输出处理程序。
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-function.ob-list-handlers-parameters">
  <h3 class="title">参数</h3>
  <p class="para">此函数没有参数。</p>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-function.ob-list-handlers-returnvalues">
  <h3 class="title">返回值</h3>
  <p class="para">
   这将返回数组，其中包含正在使用的输出处理程序（如果有）。
  </p>
  <p class="para">
   如果启用了 <a href="outcontrol.configuration.php#ini.output-buffering" class="link">output_buffering</a> 并且未设置 <a href="outcontrol.configuration.php#ini.output-handler" class="link">output_handler</a>，或者没有回调或 <strong><code><a href="reserved.constants.php#constant.null">null</a></code></strong> 传递给
   <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>，则返回<code class="literal">&quot;default output handler&quot;</code>。启用
   <a href="outcontrol.configuration.php#ini.output-buffering" class="link">output_buffering</a> 并设置 <a href="outcontrol.configuration.php#ini.output-handler" class="link">output_handler</a>相当于将<a href="functions.internal.php" class="link">内部（内置）函数</a>传递给 <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>。
  </p>
  <p class="para">
   如果将 <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> 传递给 <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>，则返回 <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> 的<a href="language.namespaces.basics.php" class="link">完全限定名称</a>。如果 <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> 是实现 <a href="language.oop5.magic.php#language.oop5.magic.invoke" class="link">__invoke()</a> 的对象，则返回该对象的 <a href="language.oop5.magic.php#language.oop5.magic.invoke" class="link">__invoke()</a> 方法的<a href="language.namespaces.basics.php" class="link">完全限定名称</a>。如果 <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> 是
   <span class="classname"><a href="class.closure.php" class="classname">Closure</a></span>，则返回 <code class="literal">&quot;Closure::__invoke&quot;</code>。
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-function.ob-list-handlers-examples">
  <h3 class="title">示例</h3>
  <p class="para">
   <div class="example" id="example-600">
    <p><strong>示例 #1 <span class="function"><strong>ob_list_handlers()</strong></span> 示例</strong></p>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #FF8000">// 使用 output_buffering=On，没有设置 output_handler<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 没有 callback 或为 null<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 匿名函数<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) { return </span><span style="color: #0000BB">$string</span><span style="color: #007700">; });<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 箭头函数<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(fn(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) =&gt; </span><span style="color: #0000BB">$string</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// first class callable<br /></span><span style="color: #0000BB">$firstClassCallable </span><span style="color: #007700">= </span><span style="color: #0000BB">userDefinedFunction</span><span style="color: #007700">(...);<br /><br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([</span><span style="color: #0000BB">$firstClassCallable</span><span style="color: #007700">, </span><span style="color: #DD0000">'__invoke'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 内部（内置）函数<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(</span><span style="color: #DD0000">'print_r'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 用户定义函数<br /></span><span style="color: #007700">function </span><span style="color: #0000BB">userDefinedFunction</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">, </span><span style="color: #0000BB">$flags</span><span style="color: #007700">) { return </span><span style="color: #0000BB">$string</span><span style="color: #007700">; };<br /><br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(</span><span style="color: #DD0000">'userDefinedFunction'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br />class </span><span style="color: #0000BB">MyClass </span><span style="color: #007700">{<br />    public static function </span><span style="color: #0000BB">staticHandle</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br /><br />    public static function </span><span style="color: #0000BB">handle</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br /><br />    public function </span><span style="color: #0000BB">__invoke</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br />}<br /><br /></span><span style="color: #FF8000">// 类或静态方法<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([</span><span style="color: #DD0000">'MyClass'</span><span style="color: #007700">,</span><span style="color: #DD0000">'staticHandle'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 对象或非静态方法<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([new </span><span style="color: #0000BB">MyClass</span><span style="color: #007700">,</span><span style="color: #DD0000">'handle'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// 可调用对象<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(new </span><span style="color: #0000BB">MyClass</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

    <div class="example-contents"><p>以上示例会输出：</p></div>
    <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">array(1) {
  [0]=&gt;
  string(22) &quot;default output handler&quot;
}
array(1) {
  [0]=&gt;
  string(22) &quot;default output handler&quot;
}
array(1) {
  [0]=&gt;
  string(7) &quot;print_r&quot;
}
array(1) {
  [0]=&gt;
  string(19) &quot;userDefinedFunction&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(21) &quot;MyClass::staticHandle&quot;
}
array(1) {
  [0]=&gt;
  string(15) &quot;MyClass::handle&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;MyClass::__invoke&quot;
}</pre>
</div>
    </div>
   </div>
  </p>
 </div>


 <div class="refsect1 seealso" id="refsect1-function.ob-list-handlers-seealso">
  <h3 class="title">参见</h3>
  <p class="para">
   <ul class="simplelist">
    <li><span class="function"><a href="function.ob-end-clean.php" class="function" rel="rdfs-seeAlso">ob_end_clean()</a> - 清空（擦除）活动缓冲区的内容并关闭它</span></li>
    <li><span class="function"><a href="function.ob-end-flush.php" class="function" rel="rdfs-seeAlso">ob_end_flush()</a> - 冲刷（发送）活动输出处理程序的返回值，并关闭活动输出缓冲区</span></li>
    <li><span class="function"><a href="function.ob-get-flush.php" class="function" rel="rdfs-seeAlso">ob_get_flush()</a> - 冲刷（发送）活动输出处理程序的返回值，返回活动输出缓冲区的内容并将其关闭</span></li>
    <li><span class="function"><a href="function.ob-start.php" class="function" rel="rdfs-seeAlso">ob_start()</a> - 打开输出控制缓冲</span></li>
   </ul>
  </p>
 </div>


</div><?php manual_footer($setup); ?>